#!/usr/bin/env python
#-*- encoding=utf8 -*-

tenside={
'amphiphiler_bau':{
'schema_anionisch':
'Die negativ geladene hydrophile Kopfgruppe wird vereinfacht als blaue Kugel dargestellt.\nDie unpolare lipophile Schwanzgruppe wird als gelber Stab dargestellt.',
'schema_kationisch':
'Die positiv geladene hydrophile Kopfgruppe wird vereinfacht als rote Kugel dargestellt.\nDie unpolare lipophile Schwanzgruppe wird als gelber Stab dargestellt.',
'schema_polare_phase':
'Die hydrophile (wässrige) Phase wird als violette Fläche dargestellt, da jedes Wassermolekül sowohl zwei positiv polarisierte H-Atome als auch ein negativ polarisiertes O-Atom besitzt.',
'schema_unpolare_phase':
'Die lipophile (ölige oder gasförmige) Phase wird als gelbe bzw. weiße Fläche dargestellt, da die Öl- bzw. Luftmoleküle eine eher unpolare Moleküloberfläche besitzen',
'strukturformel':
'Als Beispiel für ein anionisches Tensid ist wird hier das Anion der gesättigten Fettsäure \nPalmitinsäure \n(= Hexadecansäure, Summenformel: C₁₅H₃₁COOH), \nalso das \nPalmitation \n(= Hexadecanation, Summenformel: C₁₅H₃₁COO⁻) betrachtet.'
},

'benetzbarkeit':{
'negativ_polarisierte_oberflaeche':
'Da sich die unpolaren Schwanzgruppen der anionischen Tensidmoleküle entlang der Faser, die negativen polaren Kopfgruppen aber in Richtung der wässrigen Phase anordnen, wird der Wassertropfen gewissermaßen an der Faser entlangezogen. Er flacht sich noch weiter ab, die Benetzung nimmt weiter zu.',
'nur_wasser':
'Um die Anzahl der starken Wasserstoffbrückenbindungen innerhalb der wässrigen Phase zu maximieren (also aufgrund des starken inneren Zusammenhalts der Flüssigkeit = Kohäsion), kugelt sich ein Wassertropfen an einer Faser stark ab.\nDie Anhaftungskräfte (Adhäsion) zwischen der wässrigen Phase und der Faser sind also geringer.',
'tensid_loesung':
'Da die Oberlfächenspannung durch die Tensidmoleküle an der Wasser/Luft-Grenzfläche herabgesetzt wird, flacht sich der Wassertropfen etwas ab, die Kontaktfläche mit der Faser erhöht sich.'
},

'micellenbildung':{
'kugel_micellen':
'Eine häufig auftretende Micellenform sind kleine Kügelchen, bei denen die hydrophilen Kopfgruppen nach außen der wässrigen Phase zugewandt sind, die lipophilen Schwanzgruppen eine eigene kleine lipophile Phase bilden.',
'stab_micellen':
'Bei noch höheren Tensid-Konzentrationen kann es zur Bildung Stab förmiger oder sogar flächig gestapelter (= lamellarer) Micellen kommen. \nEine Sonderform einer geschlossenen lamellaren Micelle stellen Zellmembranen dar.',
'wasser_mit_viel_tensid':
'Gibt man viel Tensid in Wasser, so wird nicht nur die Grenzfläche Wasser/Luft mit Tensidmolekülen besetzt, sondern es bilden sich auch kleine Tensidmolekül Zusammenlagerungen, sogenannte Micellen. \nTriebkraft ist der Versuch, die Kontaktfläche zwischen allen polaren Moleküloberflächen zu maximieren, die zwischen polaren und unpolaren jedoch zu minimieren. \nAls Folge davon wenden sich die unpolaren Schwanzgruppen entweder einer umgebenden lipophilen Phase zu oder aber sie bilden eine eigene lipophile Phase.'
},

'oberflaechenspannung':{
'nur_wasser':
'Zwischen den Wassermolekülen der wässrigen Phase wirken starke Wasserstoffbrückenbindungen. \nDa auch die Wassermoleküle der Grenzschicht stark aneinanderhaften, kommt es zur sogenannten "Oberflächenspannung".',
'tensid_loesung':
'Tenside (von lat. tendere=spannen) sind grenzflächenaktive Substanzen. \nDie Tensidmoleküle ordnen sich so an, dass die hydrophilen polaren Kopfgruppen sich an der Wasseroberfläche anordnen und die hydrophoben unpolaren Schwanzgruppen sich in die umgebende Luft strecken. \nDurch die Abstoßung der Tensidmoleküle voneinander werden auch die Wassermoleküle an der Grenzfläche leichter voneinander getrennt. Dies setzt die Oberflächenspannung herab.',
'tensid_loesung_mit_wasserlaeufer':
'Die Füße des Wasserläufers durchstoßen nun die Wasseroberfläche und sie werden zusätzlich leichter vom Wasser benetzt. Daher sinkt er jetzt ein - Blubb!',
'wasser_mit_wasserlaeufer':
'Die durch feine Härchen an den Beinen gut verteilte Gewichtskraft des Wasserläufers führt daher nicht zu einer Trennung der Wassermoleküle voneinander, so dass seine Füße nicht benetzt werden und er nicht einsinkt.'
},

'oel_in_wasser':{
'oel_in_wasser_emulsion':
'Die Tensidmoleküle ordnen sich an der Grenzfläche zwischen den beiden Phasen an, stabilisieren die kleinen Öltröpfchen und verhindern so eine Entmischung. Da das stabilisierte heterogene Flüssig/Flüssig-Gemisch als "Emulsion" bezeichnet wird, wirken Tenside also als "Emulgatoren".',
'oel_und_wasser':
'Ein Gemisch aus einer hydrophilen und einer hydrophoben Phase entmischt sich, da wieder die Ausbildung einer größtmöglichen Anzahl gleichartiger zwischenmolekularer Kräfte, v.a der starken Wasserstoffbrückenbindungen, angestrebt wird.\nJe nach Dichte liegt eine der beiden Phase weiter oben.'
},

'schaumbildung':{
'aufsteigende_luftblase':
'Steigt die Luftblase auf, so bildet sich aus der oberen Luft/Wasser-Grenzschicht und der Luft/Wasser-Grenzschicht der Luftblase eine Wasser-Tensid-Doppelschicht aus. \nBei dieser liegen die polaren Kopfgruppen nach innen der wässrigen, und die unpolaren Schwanzgruppen nach außen der lipophilen Luftphase zugewandt.',
'freie_seifenblase':
'Bei ausreichender Tensid-Menge kann sich die Wasser/Tensid-Doppelschicht vollständig von der oberen Luft/Wasser-Grenzschicht ablösen und es entsteht eine frei schwebende Seifenblase. Reißt diese an einer Stelle auf, so trennen sich die in der Membran artigen Hülle vorhandenen Tensid- und Wassermoleküle schlagartig voneinander und die Blase platzt.',
'luftblase_in_tensid_loesung':
'Wird nun ein Luftbläschen als hydrophobe Phase in die Tensid-Lösung gepustet, so ordnen sich Tensidmoleküle an der Luft/Wasser-Grenzschicht an und stabilisieren die Luftblase.',
'nur_wasser':
'Zwischen den Wassermolekülen der wässrigen Phase wirken starke Wasserstoffbrückenbindungen.',
'wasser_mit_viel_tensid':
'Gibt man viel Tensid in Wasser, so wird nicht nur die Grenzfläche Wasser/Luft mit Tensidmolekülen besetzt, sondern es bilden sich auch kleine Tensidmolekül Zusammenlagerungen, sogenannte Micellen (Vgl. auch 3.1 Bildung von Micellen).'
},

'waschen_anionisch':{
'faserbenetzung':
'Damit das anionische Tensid anionisch bleibt und nicht protoniert wird, wird meist eine leicht alkalische Wasch"lauge" gewählt.\nDie Tensidmoleküle lagern sich mit ihrer lipophilen Schwanzgruppe an der Faser an und verbessern so die Benetzbarkeit. \n(Vgl. 2.3 Berbesserung der Benetzbarkeit)',
'fettschmutz_micellen':
'Es bilden sich stabile Fettschmutz-Micellen, die sich aufgrund der elektrostatischen Abstoßung zwischen den anionischen Kopfgruppen nicht wieder der Faser annähern. \n(Vgl. 3.1 Bildung von Micellen und 3.3 Öl-in-Wasser-Emulsion)',
'weichspueler':
'Nachdem die anionischen Tenside sowie die in der Waschlauge enthaltenen Fettschmutz-Micellen abgespült worden sind, können sich nach einer Zugabe von kationischen Tensiden (z.B. quartären Ammoniumionen) deren positiv geladenen Kopfgruppen an die negativ geladene Faser anlagern. Dies bewirkt ein Weicherwerden der Faseroberfläche. Man benutzt kationische Tenside daher als "Weichspüler".'
},

'waschen_unpolar':{
'faserbenetzung':
'Damit das anionische Tensid anionisch bleibt und nicht protoniert wird, wird meist eine leicht alkalische Wasch"lauge" gewählt.\nDie Tensidmoleküle lagern sich mit ihrer lipophilen Schwanzgruppe an der Faser an und verbessern so die Benetzbarkeit. \n(Vgl. 2.3 Berbesserung der Benetzbarkeit)',
'fettschmutz_micellen':
'Es bilden sich stabile Fettschmutz-Micellen, die sich aufgrund der elektrostatischen Abstoßung zwischen den anionischen Kopfgruppen nicht wieder der Faser annähern. \n(Vgl. 3.1 Bildung von Micellen und 3.3 Öl-in-Wasser-Emulsion)'
},

'wasser_in_oel':{
'wasser_in_oel_emulsion':
'Die Tensidmoleküle ordnen sich an der Grenzfläche zwischen den beiden Phasen an, stabilisieren die kleinen Wassertröpfchen und verhindern so eine Entmischung. Da das stabilisierte heterogene Flüssig/Flüssig-Gemisch als "Emulsion" bezeichnet wird, wirken Tenside also als "Emulgatoren".',
'wasser_und_oel':
'Ein Gemisch aus einer hydrophilen und einer hydrophoben Phase entmischt sich, da wieder die Ausbildung einer größtmöglichen Anzahl gleichartiger zwischenmolekularer Kräfte, v.a der starken Wasserstoffbrückenbindungen, angestrebt wird.\nJe nach Dichte liegt eine der beiden Phase weiter oben.'
},

'zellmembranaufbau':{
'eingebettete_proteine':
'Um (1) einen Stoffaustausch mit der Umgebung auch für polare bzw. ionische oder aber sehr große Moleküle zu ermöglichen, um (2) elektrische oder chemische Informationen aus der Umgebung oder von Nachbarzellen aufzunehmen, oder um (3) mit Hilfe eines Konzentrationsgefälles einen Stoffwechselteilschritt anzutreiben, \nliegen in diese Membran eingebettet viele verschiedene Proteine (hier grün dargestellt). \nDiese können die Membran vollständig durchdringen oder nur in eine der beiden Schichten eingebettet sein. \nSie sind meist innen an anderen Proteinen des Zellskeletts verankert.',
'lipid_doppelschicht':
'Eine Zellmembran besteht v.a. aus einer Phospholipid-Doppelschicht. Ein Phopsholipid-Molekül ist ähnlich wie ein Tensid-Molekül aus einer polaren Kopfgruppe (meist aus Glycerin und einer Phosphatgruppe) sowie einer unpolaren Schwanzgruppe (z.B. Fettsäurereste) aufgebaut. \nAufgrund des lipophilen Charakters der nach innen gerichteten Schwanzgruppen stellen Zellmembranen eine Barriere z.B. für Ionen dar und ermöglichen so einen selektiven Stoffaustausch mit der Umgebung. \nFettlösliche Moleküle wie z.B. Steroidhormone dagegen können die Zellmembran und die Kernhülle leicht durchdringen.'
}

}
